import { z } from '@hono/zod-openapi';

export const OrganizationSchema = z.object({
  id: z.number().int().positive().openapi({ description: '分行网点ID' }),
  name: z.string().min(1, '分行网点名称不能为空').max(255, '分行网点名称最多255个字符').openapi({
    description: '分行网点名称',
    example: '北京分行'
  }),
  parentId: z.number().int().nonnegative('上级ID必须为非负数').default(0).openapi({
    description: '上级网点ID',
    example: 0
  }),
  level: z.number().int().nonnegative('层级必须为非负数').default(4).openapi({
    description: '组织层级',
    example: 4
  }),
  state: z.number().int().min(1).max(2).default(1).openapi({
    description: '状态 1可用 2不可用',
    example: 1
  }),
  createdAt: z.coerce.date().openapi({
    description: '创建时间',
    example: '2024-01-01T12:00:00Z'
  }),
  updatedAt: z.coerce.date().openapi({
    description: '更新时间',
    example: '2024-01-01T12:00:00Z'
  }),
  createdBy: z.number().int().positive().nullable().openapi({
    description: '创建用户ID',
    example: 1
  }),
  updatedBy: z.number().int().positive().nullable().openapi({
    description: '更新用户ID',
    example: 1
  })
});

export const CreateOrganizationDto = z.object({
  name: z.string().min(1, '分行网点名称不能为空').max(255, '分行网点名称最多255个字符').openapi({
    description: '分行网点名称',
    example: '北京分行'
  }),
  parentId: z.number().int().nonnegative('上级ID必须为非负数').default(0).openapi({
    description: '上级网点ID',
    example: 0
  }),
  level: z.number().int().nonnegative('层级必须为非负数').default(4).openapi({
    description: '组织层级',
    example: 4
  }),
  state: z.number().int().min(1).max(2).default(1).openapi({
    description: '状态 1可用 2不可用',
    example: 1
  })
});

export const UpdateOrganizationDto = z.object({
  name: z.string().min(1, '分行网点名称不能为空').max(255, '分行网点名称最多255个字符').optional().openapi({
    description: '分行网点名称',
    example: '北京分行'
  }),
  parentId: z.number().int().nonnegative('上级ID必须为非负数').optional().openapi({
    description: '上级网点ID',
    example: 0
  }),
  level: z.number().int().nonnegative('层级必须为非负数').optional().openapi({
    description: '组织层级',
    example: 4
  }),
  state: z.number().int().min(1).max(2).optional().openapi({
    description: '状态 1可用 2不可用',
    example: 1
  })
});